# Complex Nonlinearities

[![Build](https://github.com/jatinchowdhury18/ComplexNonlinearities/actions/workflows/build.yml/badge.svg)](https://github.com/jatinchowdhury18/ComplexNonlinearities/actions/workflows/build.yml)

This repository contains recent research exploring purely digital complex nonlinear signal processing.
Articles explaining the project in further detail can be found on [Medium](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-0-why-4ad9b3eed60f). A technical project overview is available online
[here](https://ccrma.stanford.edu/~jatin/papers/Complex_NLs.pdf).

Each nonlinear effect is available as an audio plugins (VST/VST3/AU).
Builds of each plugin are available for Mac and Windows in the [Bin/](./Bin/) directory.
Linux users can find builds available on the
[Open Build Service](https://build.opensuse.org/package/show/home:kill_it:JUCE/ComplexNonlinearities),
courtesy of Konstantin Voinov.

Current nonlinearities include:

1. Double Soft Clipper
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-1-double-soft-clipper-5ce826fa82d6)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/DoubleSoftClipper.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/DoubleSoftClipper/Pics/Weird.png" alt="Pic" width="500" height="350">

2. Harmonic Exciter
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-epsiode-2-harmonic-exciter-cd883d888a43)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/Exciter.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/Exciter/Pics/exciter_static.png" alt="Pic" width="500" height="350">

3. Hysteresis
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-3-hysteresis-fdeb2cd3e3f6)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/Hysteresis.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/Hysteresis/Pics/Extreme_Hysteresis.png" alt="Pic" width="500" height="350">

4. Nonlinear Biquad
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-4-nonlinear-biquad-filters-ae6b3f23cb0e)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/NLBiquad.html)
[![Paper](https://img.shields.io/badge/Read-Paper-yellow)](https://dafx2020.mdw.ac.at/proceedings/papers/DAFx2020_paper_3.pdf)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/NonlinearBiquad/Pics/NL-LowShelf.png" alt="Pic" width="500" height="350">

5. Nonlinear Feedback
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-5-nonlinear-feedback-filters-115e65fc0402)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/NLFeedback.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/NonlinearFeedback/Pics/LPF-NL.png" alt="Pic" width="500" height="350">

6. Wavefolding
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-6-wavefolding-9529b5fe4102)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/Wavefolder.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/Wavefolder/Pics/sat_wave.png" alt="Pic" width="500" height="350">

7. Adaptive EQ
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-7-adaptive-eq-b74b889b00df)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/CopyEQ.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/CopyEQ/Pics/ex3_out.png" alt="Pic" width="500" height="350">

8. Nonlinear Allpass
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-8-nonlinear-allpass-filters-bd177c71078f)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/NLAllpass.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/NonlinearAllpass/Pics/sine_nlapf.png" alt="Pic" width="500" height="350">

9. Subharmonics Generator
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-9-subharmonics-2831ae05678b)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/Subharmonics.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/Subharmonics/Pics/half_square.png" alt="Pic" width="500" height="350">

10. Gated Recurrent Distortion
[![Medium](https://img.shields.io/badge/Read%20on-Medium-blue)](https://medium.com/@jatinchowdhury18/complex-nonlinearities-episode-10-gated-recurrent-distortion-6d60948323cf)
[![Jupyter](https://img.shields.io/badge/Read%20as-Jupyter-orange)](https://ccrma.stanford.edu/~jatin/ComplexNonlinearities/gru.html)

<img src="https://github.com/jatinchowdhury18/ComplexNonlinearities/blob/master/GatedRecurrentDistortion/Pics/wf.png" alt="Pic" width="500" height="350">

## Organization

Each subfolder contains a specific nonlinearity, including Python simulations
and a real-time implementation in JUCE/C++.

Binary files for each plugin can be found in the `Bin/` folder. Currently only Windows
builds and **unsigned** Mac builds are available.

## License

The code in this repository is freely available under the GNU General Public License
